var Sandbox, _, allRemotes, gen_jail_api, snippetsDefinition, uuid;

_ = require('lodash');

uuid = require('node-uuid');

gen_jail_api = function(cb) {
  return {
    log: console.log.bind(console),
    __finished__: cb
  };
};

snippetsDefinition = function(api) {
  return _.reduce(api.snippets, (function(acc, i, fname) {
    return acc + "\nvar " + fname + " = " + i;
  }), "");
};

allRemotes = function(api) {
  return (_.map(api.remote || {}, function(api, key) {
    return "var " + key + "=application.remote." + key;
  })).join(";");
};

Sandbox = {
  run: function(code, customApi) {
    var apiArgs, e, evalCode, id, ref, ref1, remoteApi, remotes, runner, snippets, snippetsApi;
    if (customApi == null) {
      customApi = {};
    }
    id = uuid.v4();
    snippets = snippetsDefinition(customApi);
    remotes = allRemotes(customApi);
    remoteApi = customApi.links;
    snippetsApi = _.keys(customApi.snippets);
    apiArgs = (_.union(remoteApi, snippetsApi)).join(",");
    evalCode = "var runTests = function(" + apiArgs + "){" + code + "};\nvar start = function(application){ " + remotes + ";" + snippets + ";runTests(" + apiArgs + ")};\nstart";
    try {
      runner = eval(evalCode);
      runner(customApi);
      return (ref = customApi.remote) != null ? typeof ref.finished === "function" ? ref.finished() : void 0 : void 0;
    } catch (_error) {
      e = _error;
      return (ref1 = customApi.remote) != null ? typeof ref1.failed === "function" ? ref1.failed(e) : void 0 : void 0;
    }
  },
  debug: function(code, customApi, cbs) {
    code = "debugger;" + code;
    return Sandbox.run(code, customApi, cbs);
  }
};

module.exports = Sandbox;
